pro cranknic,x,u,dt
;
;+
;  Crank Nicolson integration of diffusive part of the 
;  operator, energy equation only
;- 
@common
a=size(u)
t=reform ( (pt(u))[1,*]  )
told=t
dx=x(1)-x(0)
alpha=param.alpha
beta=alpha+1
gamma=1./beta
n=total(u[3:a[1]-1,*],1) + nelec(u)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  Newton scheme, using v as variable
;
r=param.kappa0*2./3./n/param.bconst
const=-dx*dx/dt/r
v=t^beta
count=0
au=-0.5 + v*0.
al=au
;start:
   rhs= shift(v,-1)+shift(v,1) - 2.*v
   ad=1.+v^(gamma-1.)*const
   delta=trisol(al,ad,au,rhs)
;   mx=max(abs(delta/v))
;   count=count+1
;   print,count,mx
   v=v+delta  ; update
;   if(mx lt 1.e-8 or count gt 1) then goto, done
;   goto, start
done:
;stop
;
t=v^gamma
u(2,*)=u(2,*) +param.bconst*3./2.*(t-told)*n  ; update vector
return
end


;   delta1=delta
;   au=-0.5d0 + v*0. & au=au(1:*)
;   al=au  
;   ad=1.d0+v^(gamma-1.)*const
;; Decompose a:
;   dlower = al
;   darray = ad
;   dupper = au
;   LA_TRIDC, dlower, darray, dupper, u2, index
;; Compute and improve the solution:
;   x = LA_TRISOL(dlower, darray, dupper, u2, index, rhs)
;   xnew = LA_TRIMPROVE(Al, Ad, Au, $
;                       dlower, darray, dupper, u2, index, rhs, x) 
;   delta=x
;



;
;  original Newton Raphson scheme
;
;r= param.kappa0*dt/2.d0/dx/dx
;r =r/(n*param.bconst*3./2.)
;r=r^(1./beta)
;start:
; v=t^beta  ; t^7/2
; w=t^alpha  ; t^5/2
; rhs= 2.*(shift(r*v,-1)+shift(r*v,1) -2*r*v)
;;
; au=-beta*shift(r*w,-1) & au=au(1:*)
; al=-beta*shift(r*w,1)  & al=al(0:a(2)-2)
; ad=1.+2.*beta*w*r ; diagonal
;;
; la_tridc,al,ad,au,u2,index
; delta = la_trisol(al,ad,au,u2,index,rhs)
; plot,delta,ps=3
; t=t+delta
; mx=max(abs(delta/t)) 
; print,mx
; if(max(abs(delta/t)) lt 1.e-12) then goto, ok
; stop
; str='' & read,str
;goto, start
;ok:
