;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Document name: flux.pro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
FUNCTION flux,x,u
;
; fluxes for flux conservative problem
;
@common
f = u
vel=u[1,*]/u[0,*]
vv=pt(u)
p=vv[0,*]
t=vv[1,*]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; mass
f[0,*] = u[1,*]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; momentum
f[1,*] = u[1,*]*vel + p
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; energy
if(param.osplit eq 0) then fc=fcond(x,t) else fc=0.
f[2,*] =vel*(u[2,*]+p)  +  fc  ; + frad simplest
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Hydrogen and other elements 
a=size(u)
for i=3, a(1)-1 do f[i,*] = vel * u[i,*]
return,f
END

