;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function sources,u,v
phi=0.5
return,phi*source(u)+(1.-phi)*source(v)
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro maccormack,x,u,dt,t,pdelta=pdelta
;+   
; MacCormack method, works on inner points ony
;-
@common
a=size(u)
ny=a(1) & nx=a(2)
;
; work arrays
; do not zero these:
z=u & w=u
j=1+indgen(nx-2) & jp1=j+1 & jm1=j-1
;
; dx grid
;
dx=x(1)-x(0)
;
;  FB mode:
;    predictor step, x index range is 0 to nx-2 for calculations
;
f = flux(x(j),u(*,j))
fp = flux(x(jp1),u(*,jp1))
dd= - (fp - f)/dx + sources(u(*,jp1),u(*,j))
z(*,j) = u(*,j) +dd*dt
;
; check magnitudes, reduce dt as needed
;
pdelta=changes(z,u)  ; actual changes 
;
ratio= (1./pdelta)/param.slowdown < 1.d0  ; allowed/actual
dt = (( dt*ratio ) > param.tsmall) < .1d0
;
; proceed with smaller step
;
z(*,j) = u(*,j) +dd*dt
;
; corrector step, x index range is 1 to nx-1
;
f = flux(x(j),z(*,j))  ; all well defined, on grid indices 1 to nx-2
fm = flux(x(jm1),z(*,jm1))
;
corrc =  -dt/dx*(f - fm) + sources(z(*,jm1),z(*,j))*dt
w[*,j] = u(*,j) + corrc
;
; answer
;
u = 0.5*(z+w)
;
bound,x,u
return 
end
