function radlossu,u,reset=reset
@common
common iondata, ions
common rloss_lookup,t,cool
; +
;  returns detailed radiation losses from vector u
;  in erg/cm3/s
; PGJ 27 Aug 2011.
; -
;
;  1. compute using IE
;
nne=nelec(u)
p=pt(u)
temp=reform(p(1,*))
t1=temp
desc=states()
if(param.rloss_ie eq 1) then return,ltradloss(temp)*nne*(u(3,*)+u(4,*))
;
; 2. compute those atoms and free-free not explicitly treated.
;
rloss=extraradloss(temp,desc,reset=reset)*nne*(u(3,*)+u(4,*))
;
; 3. detailed transitions from vector u
;
if(n_elements(reset) ne 0 or n_elements(ions) eq 0) then begin 
   print,'storing iondata..'
   ions=iondata()
   print,n_elements(ions),' ions acquired'
endif
;   
eold=-99
f1=8.63d-06/sqrt(temp)*param.echarge
temp=t1
const2=-param.echarge/param.bconst
for il=0,n_elements(ions)-1 do begin 
   ili=ions(il)
   e_per_ion  = ili.e0*ili.o0*exp(const2*ili.e0/temp)
   e_per_ion += ili.e1*ili.o1*exp(const2*ili.e1/temp)
   e_per_ion += ili.e2*ili.o2*exp(const2*ili.e2/temp)
   e_per_ion *=f1
;
; get population density of ions
;
   elem=ili.el
   sp=ili.sp
   if(elem ne eold) then spec=specno(elem,desc,indx)
   ok=where(spec eq sp,nm)
   if(nm gt 0) then begin 
      iond=reform(u(indx(ok),*)) ; ion density cm-3
      eold=elem
      rloss+= iond*e_per_ion*nne
;      help,ili
;      plot_oo,temp,ltradloss(temp),title=atomn(elem)+' '+roman(sp)
;      oplot,temp,rloss/nne/(u(3,*)+u(4,*)),lines=1
;      oplot,temp,iond*e_per_ion/(u(3,*)+u(4,*)),lines=2
;      if(elem eq 1) then stop
   endif
endfor
;
;plot=1
if(n_elements(plot) ne 0) then begin 
   oplot,temp,rloss/nne/(u(3,*)+u(4,*))
   oplot,temp,extraradloss(temp),ps=2
   oplot,temp,rloss/nne/(u(3,*)+u(4,*))-extraradloss(temp),ps=1
   legend,/top,/right,psym=[0,3,2,1],['r','lookup','extra','detailed']
   stop
endif

return,rloss
end

