pro rates,element,ion,temp,i,r,u=u
;+
; ionization and recombination rates cm-3
;-
@common
common shvsdata, p
if(n_elements(p) eq 0) then begin 
   p={atom:0,ion:0,acol:0.d0,tcol:0.d0,arad:0.d0,xrad:0.d0,adi:0.d0,bdi:0.d0,t0:0.d0,t1:0.d0} ; ,$
;        ivariance:0.d0,rvariance:0.d0}
   pp=p
   openr,lu,/get,param.datadir+'alldata.txt'
   ss=''
   readf,lu,ss
   readf,lu,ss
   while not eof(lu) do begin 
      readf,lu,pp
;      print,pp
      p=[p,pp]
   endwhile
   free_lun,lu
   p=p(1:*)
endif
;
k=where(p.atom eq element and p.ion eq ion,c)
if(c ne 1) then begin 
   print,element,ion
   message,' element/ion not in ion/recomb alldata.txt file in '+param.datadir
endif
;
k=k(0)


r=p(k).arad*(temp/1.e4)^(-p(k).xrad)  +  $
         p(k).adi /temp/sqrt(temp) * exp(-p(k).t0/temp)* $ 
         (1.e0+p(k).bdi * (exp(- p(k).t1/temp)))
;
i=p(k).acol * sqrt(temp) * exp( -p(k).tcol / temp) $
         / (1.0 + 0.1 * temp / p(k).tcol) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  hydrogen ionization and recombination, n=2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; assume detailed balance in L alpha in chromosphere, much smaller
; population in corona (parameter fudge below). 
; n2 is number per neutral H atom (n2/nh)
; photoionization: 
; Rudawy+Heinzel SP 138 123 (1998), table2   s-1  Ba continuum, n2*9.e3
;
if(p(k).atom eq 1 and n_elements(u) ne 0) then begin 
   e2=13.98*3./4.                                ; n=2 energy
   n2=4./exp(param.echarge*e2/param.bconst/temp)    ; Boltzmann factor
   photoion= n2*8.e3         ; VAL 3C
   fn=u[3,*]/ (u[3,*] + u[4,*] )
   fudge=fn*fn
   i += photoion*fudge /nelec(u)
   r /= (1.+fudge)             ; divide by two to remove Lyman continuum CASE B
endif

bad=where(r lt 0. or i lt 0.,c)
if(c gt 0) then message,'-ve rates'
i=reform(i)
r=reform(r)
return
end
