pro timestep,x,uold,u,dt,cfl
;+
; computes new timestep depending on 
;   - courant condition
;   - changes between u and uold.
; NOTE:  this is also done in the TVDLF procedure
;-
@common
;
a=size(u) & nx=a(2)
j=1+indgen(nx-2)
dx=x(1)-x(0)
cs=(csound(u))
xx=changes(u,uold,/notrace) 
if(xx gt .1) then param.slowdown=param.slowdown*(1.+xx) < 5.e2
cfl=min(dx/cs(j)*param.courant_n) 
dt= cfl/param.slowdown > param.tsmall
;
return
end
